<?php
/*
Dragon Go Server
Copyright (C) 2001-2014  Erik Ouchterlony, Jens-Uwe Gaspar

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* Author: Jens-Uwe Gaspar */

// Call GeneralFunctionsTest::main() if this source file is executed directly.
if (!defined("PHPUnit_MAIN_METHOD")) {
   define("PHPUnit_MAIN_METHOD", "GeneralFunctionsTest::main");
}

require_once 'PHPUnit/Framework/TestCase.php';
require_once 'PHPUnit/Framework/TestSuite.php';

require_once 'include/std_functions.php';



/**
 * Test class for general-functions.
 * Generated by PHPUnit_Util_Skeleton on 2009-11-14 at 13:32:21.
 */
class GeneralFunctionsTest extends PHPUnit_Framework_TestCase {

   /**
    * Runs the test methods of this class.
    *
    * @access public
    * @static
    */
   public static function main() {
      require_once 'PHPUnit/TextUI/TestRunner.php';

      $suite  = new PHPUnit_Framework_TestSuite("GeneralFunctionsTest");
      $result = PHPUnit_TextUI_TestRunner::run($suite);
   }


   /** Tests parseDate(). */
   public function test_parseDate() {
      $this->assertEquals( 0, parseDate('test', '', /*secs*/false) );
      $this->assertTrue( (bool)preg_match("/dateformat.*wrong.*test/i", parseDate('test', 'no-date', /*secs*/false)) );

      static $ts = 1365856577; // 2013-04-13 12:36:17
      $this->assertEquals( $ts, parseDate('test', '2013-04-13 12:36:17', /*secs*/true) );
      $this->assertEquals( $ts - 17, parseDate('test', '2013-04-13 12:36:17', /*secs*/false) );
      $this->assertEquals( $ts - 17, parseDate('test', '2013-04-13 12:36', /*secs*/false) );
      $this->assertEquals( $ts - 17, parseDate('test', '2013-04-13 12:36', /*secs*/true) );
   }

}

// Call GeneralFunctionsTest::main() if this source file is executed directly.
if (PHPUnit_MAIN_METHOD == "GeneralFunctionsTest::main") {
    GeneralFunctionsTest::main();
}
?>
